;--------------------------------------------------------------------------------
;By John Kempen
;
;Most of this code is mine, with the exception of the Mode 1 Interrupt code.
;Thanks to Matt Johnson for that bit of code.
;
;I have added some comments, hope it helps.
;
;It took me a long time to write this program, so if you use a large amount of
;my code in a program, please give me credit for it somewhere.
;
;
;E-mail me if you have any comments or questions:
;saywhat97@hotmail.com
;---------------------------------------------------------------------------------


#include "asm86.h"								;Comes with Assembly Studio
#include "asm86.inc"							;Pat Milheron's include files
#include "ram86.inc"							;
#include "HexView.h"							;addresses of temporary ram variables


;------------------------------------------------
;------------------------------------------------
.org _asm_exec_ram								;start address of assembly programs, $d748
	nop											;signal to shells that this program has a description
	jp start1									;start of the program
	.dw $0000
	.dw name									;address of the description

;------------------------------------------------
;------------------------------------------------
draw_var_menu_full1
	jp draw_var_menu_full
start1
	call installint								;installs grayscale handler into user interrupt area
	ld a,(checkbytesnum)
	cp 21										;check if the number of search bytes is 21 or less
	jr c,start1finish							;if it is, the search string was typed in program
	xor a										;if not, it was not typed in; does ld a,0
	ld (checkbytesnum),a						;set number of search bytes to 0
start1finish
	xor a										;does ld a,0
	ld (search_addr_available),a
	ld (searchentermode),a						;clear first byte
	ld hl,searchentermode						;loads the address of a lot of bytes
	ld de,searchentermode+1
	ld bc,19									;number of additional bytes to clear
	ldir										;clears multiple bytes
	ld a,1
	ld (addressshow),a							;sets address display to hexadecimal
;------------------------------------------------
start
	xor a										;does ld a,0
	ld (iy+36),a								;turn off all sqrrt programs
	call $49DC									;closes any open menus; _flushAllMenus
	res 0,(iy+18)								;turn off run indicator
	res 2,(iy+13)								;turn off appAutoScroll


;------------------------------------------------
startselvar
	res 2,(iy+$1e)								;turn off 2nd and alpha display in upper right hand corner of the screen
	ld a,$3c									;sets the current display plane to the default plane at $FC00
	out (0),a									;
	xor a										;does ld a,0
	ld (mscroll),a
	call _clrScrn
	xor a										;does ld a,0
	ld (search_addr_available),a
	jr Selectwhat2load



;------------------------------------------------
;------------------------------------------------
End
	res 3,(iy+18)
	res 4,(iy+18)
	res 5,(iy+18)
	res 6,(iy+18)
	res 7,(iy+18)
	res 2,(iy+$1e)								;turn off 2nd and alpha display in upper right hand corner of the screen
	xor a										;does ld a,0
	ld (_curRow),a
	ld a,$20
	ld (_curUnder),a
	call _clrScrn
	set 0,(iy+18)								;turn on run indicator
	set 2,(iy+13)								;turn off appAutoScroll
	res 2,(iy+$23)                  		    ;Disable user routine so IM 1 works "normally" again ;-)
	res 3,(iy+5)								;set text display to black on white
	ld a,$3c									;sets the current display plane to the default plane at $FC00
	out (0),a									;
	ld a,255									;turn on all sqrrt programs
	ld (iy+36),a								;
	ret

;------------------------------------------------
mEnd
	pop hl
	jr End



;------------------------------------------------
;------------------------------------------------
Selectwhat2load2
	pop hl
Selectwhat2load
	call Bydraw
	ld hl,End
	push hl
	ld a,1
	ld b,1
	ld hl,Selectwhattxt
	call putflines


;------------------------------------------------
Selectloadgetkey
	call clear_key_flags_getkey
	cp k1
	jp z,var_select_start
	cp k2
	jp z,Rampage
	cp k3
	jp z,Rompage
	cp k4
	jp z,About
	cp k5
	jr z,Help
	cp k6
	jr z,End
	cp kExit
	jr z,End	
	jr Selectloadgetkey



;------------------------------------------------
;------------------------------------------------
Help
	call Bydraw									;display the inverted bars on top and bottom of screen
	pop hl										;remove 2 bytes from stack so calc won't crash on program exit

;--------------------------
	ld hl,HelpView-1							;name of HelpView
	rst 20h										;move the name into OP1
	rst 10h										;check if HelpView is on the calculator
	jr c,noHelp									;if not, display an error message
	set 3,(iy+$1F)								;set the flag HelpView will use to check if it was called by a program
	ld hl,textfiledata							;settings and file name used by HelpView
	ld de,$FA70									;location that HelpView will look for the data
	ld bc,13									;number of bytes of data
	ldir										;move the data to the proper location
	ld hl,HelpView-1							;name of HelpView
	rst 20h										;move the name into OP1
	call $5730									;run HelpView, _exec_assembly
;--------------------------

	jp start									;go back to the beginning


;------------------------------------------------
noHelp
	call Bydraw
	ld a,1
	ld (_curRow),a
	ld (_curCol),a
	ld hl,nohelpviewer
	call _puts
	call _getkey
	jp start



;------------------------------------------------
;------------------------------------------------
Rampage
	call Bydraw
	ld a,2
	ld (_curRow),a
	ld a,1
	ld (_curCol),a
	ld hl,lrampage
	call _puts
	ld a,3
	ld (_curRow),a
	ld a,1
	ld (_curCol),a
	ld hl,Page
	call _puts
	xor a										;does ld a,0
	ld (lev),a
	ld a,7
	ld (maxlevs),a
	call Levelchange
	ld hl,pagetxt
	ld a,6
	ld (File_name),a
	ld de,File_name+1
	ld bc,4
	ldir
	ld a,$20
	ld (File_name+5),a
	ld a,(lev)
	call atohex
	ld hl,hexchars+1
	ld de,File_name+6
	ld bc,3
	ldir
	ld a,(lev)
	ld b,%01000000
	add a,b
	out (6),a
	ld hl,$4000
	ld (size),hl
	ld (tsize),hl
	ld a,1
	ld (pageloaded),a
	ld a,$20
	ld (type),a
	ld a,(lev)
	or a										;does cp 0
	jr z,rampage0selected
	ld hl,$8000
	ld (Addressoffset),hl
	ld a,1
	ld (search_addr_available),a
	jp Editbegin


;------------------------------------------------
rampage0selected
	ld hl,$C000
	ld (Addressoffset),hl
	ld a,1
	ld (search_addr_available),a
	jp Editbegin



;------------------------------------------------
;------------------------------------------------
Rompage
	call Bydraw
	ld a,2
	ld (_curRow),a
	ld a,1
	ld (_curCol),a
	ld hl,lrompage
	call _puts
	ld a,3
	ld (_curRow),a
	ld a,1
	ld (_curCol),a
	ld hl,Page
	call _puts
	xor a										;does ld a,0
	ld (lev),a
	ld a,15
	ld (maxlevs),a
	call Levelchange
	ld hl,pagetxt
	ld a,6
	ld (File_name),a
	ld de,File_name+1
	ld bc,4
	ldir
	ld a,$20
	ld (File_name+5),a
	ld a,(lev)
	call atohex
	ld hl,hexchars+1
	ld de,File_name+6
	ld bc,3
	ldir
	ld a,(lev)
	ld b,0
	add a,b
	out (6),a
	ld hl,$4000
	ld (size),hl
	ld (tsize),hl
	ld a,1
	ld (pageloaded),a
	ld a,$21
	ld (type),a
	ld a,(lev)
	or a										;does cp 0
	jr z,rompage0selected
	ld hl,$4000
	ld (Addressoffset),hl
	ld a,1
	ld (search_addr_available),a
	jp Editbegin

;------------------------------------------------
rompage0selected
	ld hl,0
	ld (Addressoffset),hl
	ld a,1
	ld (search_addr_available),a
	jp Editbegin



;------------------------------------------------
;------------------------------------------------
About
	call Bydraw
	xor a										;does ld a,0
	ld b,2
	ld hl,Abouttxt
	call putflines
	call _getkey
	cp kExit
	jp z,mEnd
	jp Selectwhat2load



;------------------------------------------------
;------------------------------------------------
Bydraw
	call _clrScrn
	set 3,(iy+5)								;set text display to white on black
	ld a,7
	call Invbar
	ld a,7
	ld (_curRow),a
	xor a										;does ld a,0
	ld (_curCol),a
	ld hl,bytext
	call _puts
	ld a,7
	ld (_curRow),a
	ld a,18
	ld (_curCol),a
	ld hl,versionnum
	call _puts


;------------------------------------------------
Namedraw
	xor a										;does ld a,0
	call Invbar
	xor a										;does ld a,0
	ld (_curRow),a
	ld (_curCol),a
	ld hl,nametext
	call _puts
	res 3,(iy+5)								;set text display to black on white
	ret


;------------------------------------------------
Invbar
	set 3,(iy+5)								;set text display to white on black
	push af
	ld hl,$c0f8
	ld a,$20
	ld (hl),a
	ld de,$c0f9
	ld bc,21
	ldir
	pop af
	ld (_curRow),a
	xor a										;does ld a,0
	ld ($c10e),a
	ld (_curCol),a
	ld hl,$c0f9
	call _puts
	ret



;------------------------------------------------
;------------------------------------------------
atodec
	ld b,a
	ld c,a
	xor a										;does ld a,0
	ld (hexchars),a
	ld (hexchars+1),a
	ld (hexchars+2),a
atodecloop
	ld a,b
	or a										;does cp 0
	jr z,atodecfinish
	dec a
	ld b,a
	ld a,(hexchars+2)
	inc a
	cp 10
	jr z,atodecinc10
	ld (hexchars+2),a
	jr atodecloop
atodecinc10
	xor a										;does ld a,0
	ld (hexchars+2),a
	ld a,(hexchars+1)
	inc a
	cp 10
	jr z,atodecinc100
	ld (hexchars+1),a
	jr atodecloop
atodecinc100
	xor a										;does ld a,0
	ld (hexchars+1),a
	ld a,(hexchars)
	inc a
	ld (hexchars),a
	jr atodecloop
atodecfinish
	xor a										;does ld a,0
	ld (hexchars+3),a
	ld a,(hexchars)
	add a,$30
	ld (hexchars),a
	ld a,(hexchars+1)
	add a,$30
	ld (hexchars+1),a
	ld a,(hexchars+2)
	add a,$30
	ld (hexchars+2),a
	ld a,9
	cp c
	jr nc,notens
	ld a,99
	cp c
	jr nc,nohundreds
	ret
notens
	ld a,$20
	ld (hexchars+1),a
nohundreds
	ld a,$20
	ld (hexchars),a
	ret


;------------------------------------------------
atobin
	ld b,a
	or a
	and %10000000
	rl a
	rl a
	add a,$30
	ld (hexchars),a
	ld a,b
	or a
	and %01000000
	rl a
	rl a
	rl a	
	add a,$30
	ld (hexchars+1),a
	ld a,b
	or a
	and %00100000
	rl a
	rl a
	rl a
	rl a	
	add a,$30
	ld (hexchars+2),a
	ld a,b
	or a
	and %00010000
	rr a
	rr a
	rr a
	rr a	
	add a,$30
	ld (hexchars+3),a
	ld a,b
	or a
	and %00001000
	rr a
	rr a
	rr a	
	add a,$30
	ld (hexchars+4),a
	ld a,b
	or a
	and %00000100
	rr a
	rr a
	add a,$30
	ld (hexchars+5),a
	ld a,b
	or a
	and %00000010
	rr a
	add a,$30
	ld (hexchars+6),a
	ld a,b
	or a
	and %00000001
	add a,$30
	ld (hexchars+7),a
	xor a										;does ld a,0
	ld (hexchars+8),a
	ret


;------------------------------------------------
disp_atohex
	call atohex
	ld hl,hexchars
	call _puts
	ret


;------------------------------------------------
atohex											;convert number in register a into a printable string
	push af
	push hl
	push de
	push bc
	ld b,a
	and %00001111
	ld c,a
	ld a,b
	or a
	and %11110000
	rr a
	rr a
	rr a
	rr a
	ld e,a
	ld d,0
	ld hl,hexcharstable
	add hl,de
	ld a,(hl)
	ld (hexchars),a
	ld e,c
	ld d,0
	ld hl,hexcharstable
	add hl,de
	ld a,(hl)
	ld (hexchars+1),a
	xor a										;does ld a,0
	ld (hexchars+2),a
	pop bc
	pop de
	pop hl
	pop af
	ret






var_select_finish
	ld a,(row)
	sub minscrnrow-1
	ld b,a
	ld de,9
	ld hl,var_data-9
var_select_finish_loop
	add hl,de
	djnz var_select_finish_loop
	push hl
	ld de,File_name
	ld bc,9
	ldir
	xor a
	ld (hl),a
	pop hl
	call var_select_get_size_and_type
	jp editvar


var_select_get_size_and_type
	push hl
	dec hl
	rst 20h
	rst 10h
	and $1f
	ld (type),a
	ex de,hl
	call $477f
	ld h,d
	ld l,e
	ld (tsize),hl
	ex de,hl
	pop hl
	ld a,(hl)
	ex de,hl
	ld b,6
	add a,b
	ld e,a
	ld d,0
	xor a										;does ld a,0
	or a
	add hl,de
	ld (size),hl
	ret


;------------------------------------------------
editvardrawscreen
	call _clrScrn
	call editvarinfodraw
	call Namedraw
	set 3,(iy+5)								;set text display to white on black
	xor a										;does ld a,0
	ld (_curRow),a
	ld a,12
	ld (_curCol),a
	ld hl,File_name+1
	ld a,(File_name)
	call put_string
	ret


;------------------------------------------------
editvarinfodraw
	ld a,7
	call Invbar
	set 3,(iy+5)								;set text display to white on black
	ld a,7
	ld (_curRow),a
	xor a										;does ld a,0
	ld (_curCol),a
	ld hl,(size)
	call $4a33
	ld a,(hexbindec)
	cp 1
	ret z
	ld a,7
	ld (_curRow),a
	ld a,12
	ld (_curCol),a
	call typetableloopup
	call _puts
	ret




var_select_start
	call Bydraw
	ld a,1
	ld (_curRow),a
	ld (_curCol),a
	ld hl,sorting
	call _puts
	call SortVAT
	xor a										;does ld a,0
	ld hl,var_data
	ld (hl),a
	ld de,var_data+1
	ld bc,71
	ldir
	ld a,minscrnrow
	ld (row),a
	ld a,9
	ld (rowl),a
	call var_data_get
	call draw_var_menu_full
	call selectvar_draw_arrows
	jp var_menu_draw
var_select_keyloop
	call _getkey
	cp kExit
	jp z,End
	cp kUp
	jr z,var_select_up
	cp kDown
	jr z,var_select_down
	cp kEnter
	jp z,var_select_finish
	cp kF2
	jp z,start
	jr var_select_keyloop




var_select_up
	ld a,(row)
	cp minscrnrow
	jr z,var_menu_scroll_up
	dec a
	ld (row),a
	jp var_menu_draw
var_menu_scroll_up
	ld hl,(vat_low_ptr)
	ld de,vat_bottom
	or a
	sbc hl,de
	jp z,var_menu_draw
	call var_data_scroll_up
	call draw_var_menu_scrollup


	xor a
	cp maxscrnrow-minscrnrow
	jr z,scroll_no_lrow


	ld a,minscrnrow+1
	ld (rowl),a
	call selectvar_draw_arrows
	jr var_menu_draw

draw_var_menu_scrollup
	ld bc,(maxscrnrow-minscrnrow)*128-1
	ld de,((maxscrnrow+1)*128)+$FBFF
	ld hl,(maxscrnrow*128)+$FBFF
	ld a,$ff
	cp b
	jr z,draw_scrollup_nomove
	inc bc
	lddr
draw_scrollup_nomove
	ld a,minscrnrow
	ld hl,var_data
	call draw_menu_row
	ret

scroll_no_lrow
	ld a,9
	ld (rowl),a
	jr var_menu_draw

var_select_down
	ld a,(var_num_vars)
	dec a
	add a,minscrnrow
	ld b,a
	ld a,(row)
	cp b
	jr nc,var_menu_draw
	cp maxscrnrow
	jr z,var_menu_scroll_down
	inc a
	ld (row),a
	jr var_menu_draw
var_menu_scroll_down
	ld hl,(vat_high_ptr)
	ld a,(hl)
	inc a
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ex de,hl
	ld hl,(vat_top)
	or a
	sbc hl,de
	jr nc,var_menu_draw
	call var_data_scroll_down
	call draw_var_menu_scrolldown
	xor a
	cp maxscrnrow-minscrnrow
	jr z,scroll_no_lrow
	ld a,maxscrnrow-1
	ld (rowl),a

	call selectvar_draw_arrows

	jr var_menu_draw

draw_var_menu_scrolldown
	ld de,(minscrnrow*128)+$FC00
	ld hl,((minscrnrow+1)*128)+$FC00
	ld bc,(maxscrnrow-minscrnrow)*128-1
	ld a,$ff
	cp b
	jr z,draw_scrolldown_nomove
	inc bc
	ldir
draw_scrolldown_nomove
	ld a,maxscrnrow
	ld hl,((maxscrnrow-minscrnrow)*9)+var_data
	call draw_menu_row
	ret

var_menu_draw
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,(rowl)
	cp 9
	jr z,var_menu_no_last_row
	ld (_curRow),a
	ld a,$20
	call _putmap

var_menu_no_last_row
	ld a,(row)
	ld (rowl),a
	ld (_curRow),a
	ld a,5
	call _putmap
	ld a,(row)
	sub minscrnrow
	inc a
	ld b,a
	ld de,9
	ld hl,var_data-9
var_menu_draw_type_loop
	add hl,de
	djnz var_menu_draw_type_loop
	dec hl
	rst 20h
	rst 10h
	and $1f
	ld (type),a
	call typetableloopup
	ld a,7
	ld (_curRow),a
	ld a,16
	ld (_curCol),a
	set 3,(iy+5)
	ld hl,(moreinfo)
	call _puts
	res 3,(iy+5)
	jp var_select_keyloop


draw_var_menu_full
	call var_area_clr
	ld a,minscrnrow
	ld hl,var_data
draw_var_menu_loop
	push af
	push hl
	call draw_menu_row
	pop hl
	pop af
	ld de,9
	add hl,de
	cp maxscrnrow
	ret z
	inc a
	jr draw_var_menu_loop

draw_menu_row
	ld (_curRow),a
	ld a,1
	ld (_curCol),a
	push hl
	ld a,(hl)
	inc hl
	push af
	call put_string
	pop bc
	ld a,8
	sub b
	ld hl,spaces
	call put_string
	ld a,10
	ld (_curCol),a
	pop hl
	call var_select_get_size_and_type
	call $4a33
	ld a,16
	ld (_curCol),a
	call typetableloopup
	call _puts
	ret



var_area_clr
	ld bc,((maxscrnrow-minscrnrow+1)*128)-1
	ld hl,((minscrnrow)*128)+$FC00
	ld de,((minscrnrow)*128)+$FC01
	xor a
	ld (hl),a
	ldir
	ret

var_data_scroll_up
	ld a,%01000111
	out (6),a
	ld hl,(vat_high_ptr)
	ld de,6
	or a
	add hl,de
vat_data_up_highptr_sub
	inc hl
	ld a,(hl)
	cp 9
	jr nc,vat_data_up_highptr_sub
	ld (vat_high_ptr),hl
	ld hl,var_data+62
	ld de,var_data+71
	ld bc,63
	lddr
	ld a,9
	ld (var_num_vars),a
	ld hl,(vat_low_ptr)
vat_data_up_lowptr_sub
	inc hl
	ld a,(hl)
	cp 9
	jr nc,vat_data_up_lowptr_sub
	ld de,var_data
	push hl
	call copy_from_vat_to_table
	pop hl
	ld de,5
	or a
	add hl,de
	ld (vat_low_ptr),hl
	ret



var_data_scroll_down
	ld a,%01000111
	out (6),a
	ld hl,(vat_high_ptr)
	ld de,var_data_last_entry
	ld a,maxscrnrow-minscrnrow+1
	ld (var_num_vars),a
	ld a,(hl)
	ld b,1
	call var_data_get_loop
	or a										;does cp 0
	ret z
	ld (vat_high_ptr),hl
	ld hl,(vat_low_ptr)
	ld de,5
	or a
	sbc hl,de
	ld a,(hl)
	inc a
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ld (vat_low_ptr),hl
	ld hl,var_data+9
	ld de,var_data
	ld bc,72				;63
	ldir
	ret


var_data_get
	ld a,%01000111
	out (6),a
	ld hl,vat_bottom
	ld de,var_data
	xor a										;does ld a,0
	ld (var_num_vars),a
	ld a,-1
	ld b,maxscrnrow-minscrnrow+1
	call var_data_get_loop
	ld (vat_high_ptr),hl
	ld hl,vat_bottom
	ld (vat_low_ptr),hl
	ret

var_data_get_end
	pop hl
	pop de
	pop bc
	xor a										;does ld a,0
	ret

var_data_get_loop
	push bc
	push de
	add a,6
	ld e,a
	ld d,0
	or a
	sbc hl,de
	push hl
	or a
	ld de,(vat_top)
	dec de
	sbc hl,de
	jr c,var_data_get_end
	pop hl
	ld a,(hl)
	pop de
	push af
	push hl
	push de
	ld a,(var_num_vars)
	inc a
	ld (var_num_vars),a
	call copy_from_vat_to_table
	pop de
	ld hl,9
	or a
	add hl,de
	ex de,hl
	pop hl
	pop af
	pop bc
	djnz var_data_get_loop
	ld a,9
	ld (var_num_vars),a
	ret


copy_from_vat_to_table
	ld a,(hl)	
	ld b,a
	ex de,hl
	ld (hl),a
	ex de,hl
	dec hl
	inc de
copy_from_vat_loop
	ld a,(hl)	
	ex de,hl
	ld (hl),a
	ex de,hl
	dec hl
	inc de
	djnz copy_from_vat_loop
	ret

selectvar_draw_arrows
	set 3,(iy+5)
	xor a
	ld (_curRow),a
	ld a,18
	ld (_curCol),a
	ld hl,(vat_low_ptr)
	ld de,vat_bottom
	or a
	sbc hl,de
	jp z,selectvar_draw_no_up
	ld a,$1e
	call _putmap
	
selectvar_draw_down
	ld a,20
	ld (_curCol),a
	ld a,%01000111
	out (6),a
	ld hl,(vat_high_ptr)
	ld a,(hl)
	inc a
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ex de,hl
	ld hl,(vat_top)
	or a
	sbc hl,de
	jr nc,selectvar_draw_no_down
	ld a,$1f
	call _putmap


selectvar_draw_finish
	ld a,19
	ld (_curCol),a
	ld a,$2f						;/
	call _putmap
	res 3,(iy+5)
	ret

selectvar_draw_no_up
	ld a,$20
	call _putmap
	jr selectvar_draw_down
selectvar_draw_no_down
	ld a,$20
	call _putmap
	jr selectvar_draw_finish


;------------------------------------------------
typetableloopup
	ld a,(type)
	inc a
	ld b,a
typetableloopupnext
	ld hl,typetxttable-4
	ld de,4
typeloopdisp
	or a
	add hl,de
	djnz typeloopdisp
	push hl
	call $4010
	ld (moreinfo),hl
	pop hl
	inc hl
	inc hl
	call $4010
	ld a,(hl)
	inc hl
	ld (sizeoff),a
	ld a,(type)
	ret





;------------------------------------------------
;------------------------------------------------
editvar
	ld hl,0
	ld (Addressoffset),hl
	ld a,(type)
	cp $12
	call z,editcheckifasm
	ld hl,File_name-1
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	call _SET_ABS_SRC_ADDR
	ld a,1
	ld hl,0
	call _SET_ABS_DEST_ADDR
	xor a										;does ld a,0
	ld hl,(size)
	call _SET_MM_NUM_BYTES
	call _mm_lDIR


;------------------------------------------------
Editbegin
	set 2,(iy+$1e)								;display 2nd and alpha status in upper right hand corner of screen
	call _clrScrn
	call drawsecscreen							;clear the alternate display plane
	call editvardrawscreen
	res 3,(iy+5)								;set text display to black on white
	xor a										;does ld a,0
	ld (rowmax),a
	ld (noscroll),a
	ld a,5
	ld (colmax),a
	call draweditscreen
	xor a										;does ld a,0
	ld (col),a
	inc a
	ld (row),a
	ld hl,0
	ld (mr),hl
	jp editvardraw



;------------------------------------------------
;------------------------------------------------
editvarkeyloop
	call clear_key_flags_getkey
editvarkeyloop_keypressed
	cp kExit
	jp z,End
	cp kF1
	jp z,Help
	cp kF2
	jp z,startselvar
	cp kF3
	jp z,hexbindecdecide
	cp kGrMenu
	jp z,graphicstoggle
	cp kTable
	jp z,grayscalecontrol
	ld b,a
	ld a,(full)
	cp 1
	jr z,jumpoveradjust	
	ld a,b
	cp kAdd
	jp z,graphwidthup
	cp kSub
	jp z,graphwidthdown
	cp kMul
	jp z,graphhightup
	cp kDiv
	jp z,graphhightdown
	cp kLog
	jp z,addressontoggle
	ld b,a
jumpoveradjust
	ld a,b
	cp kExpon
	jp z,graphicinccontrol
	cp kVarx
	jp z,fullgraphcontrol
	ld b,a
	ld a,(nodata)
	cp 1
	jr z,editvarkeyloop
	ld a,b
	cp kCustom
	jp z,editvarupbyk
	cp kTan
	jp z,editvardownbyk
	cp kPrgm
	jp z,searchstring_up
	cp kCos
	jp z,searchstring_down
	cp kSin
	jp z,searchstring_enter
	cp kEE
	jp z,search_address
	cp kLn
	jp z,addr_input
	cp kRParen
	jp z,find_var_bottom
	cp kLParen
	jp z,Editbegin
	cp kUp
	jp z,editvarup
	cp kDown
	jp z,editvardown
	cp kLeft
	jp z,editvarleft
	cp kRight
	jp z,editvarright
	jp editvarkeyloop



;------------------------------------------------
;------------------------------------------------
search_address
	ld a,(search_addr_available)
	cp 1
	jp nz,editvarkeyloop
	ld a,7
	ld (_curRow),a
	xor a										;does ld a,0
	ld (_curCol),a
	ld hl,(search_addr)
	ld de,(Addressoffset)
	or a
	sbc hl,de
	jr z,search_address_inrange
	jr c,search_address_outofrange
	ld de,(Addressoffset)
	ld hl,(tsize)
	dec hl
	or a
	add hl,de
	dec hl
	dec hl
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	add hl,de
	ex de,hl
	ld hl,(search_addr)
	or a
	sbc hl,de
	jr z,search_address_inrange
	jr nc,search_address_outofrange
search_address_inrange
	call findcursorbyte							;finds the address of the currently highlighted byte
	ld de,$8000
	or a
	sbc hl,de
	ex de,hl
	ld hl,(Addressoffset)
	or a
	add hl,de
	xor a										;does ld a,0
	ld (_curCol),a
	ld (_curRow),a
	ld de,(search_addr)
	or a
	sbc hl,de
	jp c,addr_search_s_down


;------------------------------------------------
addr_search_s_up
	ld hl,(search_addr)
	ld de,(Addressoffset)
	or a
	sbc hl,de
	ld de,$8002
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	jp scroll_up_to_hl

;------------------------------------------------
addr_search_s_down
	ld hl,(search_addr)
	ld de,(Addressoffset)
	or a
	sbc hl,de
	ld de,$8002
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	jp scroll_down_to_hl


;------------------------------------------------
search_address_outofrange
	ld a,7
	call Invbar
	ld a,7
	ld (_curRow),a
	xor a										;does ld a,0
	ld (_curCol),a
	set 3,(iy+5)								;set text display to white on black
	ld hl,search_address_outofrange_txt
	call _puts
	res 3,(iy+5)								;set text display to black on white
	call _getkey
	ld (keynum),a
	ld a,1
	ld (keypressed),a
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
editvarupbyk
	ld a,1
	ld (mscroll),a
	ld b,200
editvarupbykloop
	push bc
	call editvarup
	pop bc
	djnz editvarupbykloop
	xor a										;does ld a,0
	ld (mscroll),a
	jp redrawscreen


;------------------------------------------------
editvardownbyk
	ld a,1
	ld (mscroll),a
	ld b,200
editvardownbykloop
	push bc
	call editvardown
	pop bc
	djnz editvardownbykloop
	xor a										;does ld a,0
	ld (mscroll),a
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
cpstart
	push hl
	push hl
	ld hl,$8002
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	dec hl


	pop de
	or a
	sbc hl,de
	jr z,cpstartscroll
	pop hl
	xor a										;does ld a,0
	ret
cpstartscroll
	pop hl
	ld a,1
	ret



;------------------------------------------------
;------------------------------------------------
searchstring_up
	ld a,(checkbytesnum)
	or a										;does cp 0
	jp z,searchstring_nostring

	ld a,7
	call Invbar
	ld a,7
	ld (_curRow),a
	xor a										;does ld a,0
	ld (_curCol),a
	ld hl,searching
	set 3,(iy+5)								;set text display to white on black
	call _puts
	res 3,(iy+5)								;set text display to black on white

	call findcursorbyte							;finds the address of the currently highlighted byte
	ld (searchhl),hl
searchstring_uploop
	ld hl,(searchhl)
	dec hl
	ld (searchhl),hl
	call cpstart
	cp 1
	jp z,searchstringendnone
	call searchcheck
	cp 1
	jr nz,searchstring_uploop
	xor a										;does ld a,0
	ld (noscroll),a
	ld a,(checkbytesnum)
	ld e,a
	ld d,0
	or a
	sbc hl,de


;------------------------------------------------
scroll_up_to_hl
	push hl
	call search_draw_scrolling					;inverts bottom row, draws "Scrolling..." text inverted
	ld a,1
	ld (mscroll),a
	xor a										;does ld a,0
	ld (col),a
	ld de,$8002
	ld hl,(mr)
	or a
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	pop de
	push de
	or a
	ex de,hl
	sbc hl,de
	jr nc,searchupbykloopskip
searchupbykloop
	call editvarup
	ld de,$8002
	ld hl,(mr)
	or a
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	pop de
	push de
	or a
	ex de,hl
	sbc hl,de
	jr c,searchupbykloop
searchupbykloopskip
	jp searchdownmovecursorstart





;------------------------------------------------
search_draw_scrolling							;inverts bottom row, draws "Scrolling..." text inverted
	ld a,7
	call Invbar
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,7
	ld (_curRow),a
	ld hl,scrollingtxt
	set 3,(iy+5)								;set text display to white on black
	call _puts
	res 3,(iy+5)								;set text display to black on white
	ret



;------------------------------------------------
;------------------------------------------------
searchstring_down
	ld a,(checkbytesnum)
	or a										;does cp 0
	jp z,searchstring_nostring

	ld a,7
	call Invbar
	ld a,7
	ld (_curRow),a
	xor a										;does ld a,0
	ld (_curCol),a
	ld hl,searching
	set 3,(iy+5)								;set text display to white on black
	call _puts
	res 3,(iy+5)								;set text display to black on white

	call findcursorbyte							;finds the address of the currently highlighted byte
searchstring_downloop
	inc hl
	call cphlsize
	ld a,(noscroll)
	cp 1
	jp z,searchstringendnone
	ld (searchhl),hl
	call searchcheck
	cp 1
	jr nz,searchstring_downloop
	xor a										;does ld a,0
	ld (noscroll),a
	ld a,(checkbytesnum)
	ld e,a
	ld d,0
	or a
	sbc hl,de


;------------------------------------------------
scroll_down_to_hl
	push hl
	call search_draw_scrolling					;inverts bottom row, draws "Scrolling..." text inverted
	ld a,1
	ld (mscroll),a
	xor a										;does ld a,0
	ld (col),a
	ld de,$8002
	ld hl,(mr)
	or a
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ld de,4
	add hl,de
	pop de
	push de
	or a
	sbc hl,de
	jr nc,searchdownmovecursorstart

searchdownbykloop
	call editvardown
	ld de,$8002
	ld hl,(mr)
	or a
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ld de,4
	add hl,de
	pop de
	push de
	or a
	sbc hl,de
	jr c,searchdownbykloop


;------------------------------------------------
searchdownmovecursorstart
	ld a,(col)
	dec a
	ld (col),a
searchdownmovecursor
	ld a,(col)
	inc a
	ld (col),a
	call findcursorbyte							;finds the address of the currently highlighted byte
	pop de
	push de
	or a
	sbc hl,de
	jr nz,searchdownmovecursor
	pop de

	xor a										;does ld a,0
	ld (mscroll),a
	jp redrawscreen


;------------------------------------------------
searchstringendnone
	ld a,7
	call Invbar
	ld hl,stringnotfound
searchstringendnone1
	xor a										;does ld a,0
	ld (_curCol),a
	ld (noscroll),a
	ld a,7
	ld (_curRow),a
	set 3,(iy+5)								;set text display to white on black
	call _puts
	res 3,(iy+5)								;set text display to black on white
	call clear_key_flags_getkey
	ld (keynum),a
	ld a,1
	ld (keypressed),a
	jp redrawscreen


;------------------------------------------------
searchstring_nostring
	ld a,7
	call Invbar
	ld hl,nostring
	jr searchstringendnone1


;------------------------------------------------
searchcheck
	ld a,(checkbytesnum)
	ld b,a
	or a										;does cp 0
	jr z,searchno1
	ld de,checkbytes
checkstringloop
	push bc
	ld a,(hl)
	ld b,a
	ex de,hl
	ld a,(hl)
	ex de,hl
	cp b
	jr nz,searchno
	inc hl
	inc de
	pop bc
	djnz checkstringloop
searchyes
	ld a,1
	ret
searchno
	pop bc
searchno1
	xor a										;does ld a,0
	ret



;------------------------------------------------
;------------------------------------------------
searchstring_enter
	call drawsecscreen							;clear the alternate display plane
	ld bc,21
	ld hl,checkbytesnum
	ld de,newcheckbytesnum
	ldir
	call searchredraw


;------------------------------------------------
addcharloop
;	ld a,(searchentermode)
	jp Selectlevs_search


;------------------------------------------------
addcharloop_charentered					;chararacter number in "a" register
	push af
	ld a,(newcheckbytesnum)
	cp 20
	jr z,addcharloop
	push af
	inc a
	ld (newcheckbytesnum),a
	pop af
	ld e,a
	ld d,0
	ld hl,newcheckbytes
	or a
	add hl,de
	pop af
	ld (hl),a
	ld hl,newcheckbytes
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,4
	ld (_curRow),a
	ld a,(newcheckbytesnum)
	call put_string
	jr addcharloop


;------------------------------------------------
search_saveandexit
	ld hl,newcheckbytesnum
	ld de,checkbytesnum
	ld bc,21
	ldir
	jp redrawscreen


;------------------------------------------------
search_stringdelchar
	ld a,(newcheckbytesnum)
	or a										;does cp 0
	jr z,addcharloop
	dec a
	ld (newcheckbytesnum),a
	ld (_curCol),a
	ld a,4
	ld (_curRow),a
	ld a,$20
	call _putmap
	jr addcharloop


;------------------------------------------------
searchmodechange
	ld a,(searchentermode)
	cp searchenter_num								;max number of character entry methods
	jr z,searchmodeloop
	inc a
	ld (searchentermode),a
	call searchredraw
	jr addcharloop

searchmodeloop
	xor a										;does ld a,0
	ld (searchentermode),a
	call searchredraw
	jr addcharloop


;------------------------------------------------
searchenter_keys
;	cp kNext
;	jr z,searchmodechange
	cp kF2
	jr z,search_saveandexit
	cp kExit
	jp z,redrawscreen
	cp kDel
	jr z,search_stringdelchar
	jp (hl)


;------------------------------------------------
Selectlevs_search
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,2
	ld (_curRow),a
	ld hl,charselecttxt
	call _puts
	jr Selectlevdraw_search
selectlevloop_search
	call _getkey
	ld hl,selectlevloop_search_1
	jr searchenter_keys
selectlevloop_search_1
	cp kEnter
	jr z,selectlevloopend_search
	cp kUp
	jr z,Selectlevup_search
	cp kDown
	jr z,Selectlevdown_search



	cp $6c
	jr nc,selectlevloop_search
	cp $5
	jr c,selectlevloop_search
	sub 5
	ld hl,keytable
	ld e,a
	ld d,0
	or a
	add hl,de
	ld a,(hl)
	or a										;does cp 0
	jr z,selectlevloop_search
	ld (charnum),a
	jp addcharloop_charentered


Selectlevup_search
	ld a,(charnum)
	dec a
	ld (charnum),a
	jr Selectlevdraw_search
Selectlevdown_search
	ld a,(charnum)
	inc a
	ld (charnum),a
	jr Selectlevdraw_search
Selectlevdraw_search
	ld a,2
	ld (_curRow),a
	ld a,14
	ld (_curCol),a
	ld a,(charnum)
	cp $d6
	jr nz,selectlevdraw_char
	ld a,$3a
selectlevdraw_char
	call _putmap
	ld a,18
	ld (_curCol),a
	ld a,(charnum)

	call disp_atohex

	ld a,4
	call _putmap
	jp selectlevloop_search
selectlevloopend_search								; loads selected world into savelev for saved games
	ld a,(charnum)
	jp addcharloop_charentered


;------------------------------------------------
searchredraw
	call Bydraw

	ld a,1
	ld (_curRow),a
	ld a,16
	ld (_curCol),a
	ld a,(searchentermode)
	inc a
	ld l,a
	xor a										;does ld a,0
	ld h,a

	call $4a33

	ld a,5
	ld (_curRow),a
	ld hl,previous
	call _puts
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,3
	ld (_curRow),a
	ld hl,current
	call _puts
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,6
	ld (_curRow),a
	ld hl,checkbytes
	ld a,(checkbytesnum)
	call put_string
	ld hl,newcheckbytes
	xor a										;does ld a,0
	ld (_curCol),a
	ld a,4
	ld (_curRow),a
	ld a,(newcheckbytesnum)
	call put_string
	ret


;------------------------------------------------
put_string
	or a										;does cp 0
	ret z
	ld b,a
search_putpreviousloop
	push bc
	push hl
	ld a,(hl)
	cp $d6
	jr nz,search_putnot_enter
	ld a,$3a
search_putnot_enter
	call _putc
	pop hl
	inc hl
	pop bc
	djnz search_putpreviousloop
	ret



;------------------------------------------------
;------------------------------------------------
editvarleft
	ld a,(col)
	or a										;does cp 0
	jr z,editvarleftscroll
	dec a
	ld (col),a
	jp editvardraw
editvarleftscroll
	ld a,4
	ld (col),a
	jp editvarup


;------------------------------------------------
editvarright
	ld a,(col)
	cp 4
	jr z,editvarrightscroll
	inc a
	ld (col),a
	ld a,(row)
	ld b,a
	ld a,(rowmax)
	cp b
	jp nz,editvardraw
	ld a,(col)
	ld b,a
	ld a,(colmax)
	cp b
	jp c,editvarmovecol
	jp editvardraw
editvarrightscroll
	xor a										;does ld a,0
	ld (col),a
	jp editvardown


;------------------------------------------------
editvarup
	ld a,(row)
	cp 1
	jr z,editvarscrollup
	dec a
	ld (row),a
	ld hl,(mr)
	ld de,5
	or a
	sbc hl,de
	ld (mr),hl
	jp editvardraw
editvarscrollup
	ld hl,(mr)
	xor a										;does ld a,0
	cp h
	jr z,editvarscrolluph
	jr editvarscrolluprest
editvarscrolluph
	xor a										;does ld a,0
	cp l
	jp z,editvarupend
	jr editvarscrolluprest
editvarupend
	xor a										;does ld a,0
	ld (col),a
	jp editvardraw
editvarscrolluprest
	xor a										;does ld a,0
	ld (rowmax),a
	ld (noscroll),a
	ld a,5
	ld (colmax),a

	ld a,1
	ld (row),a
	ld hl,(mr)
	ld de,5
	or a
	sbc hl,de
	ld (mr),hl
	call drawrows
	ld a,1
	ld (row),a
	ld hl,(mr)
	ld de,30
	or a
	sbc hl,de
	ld (mr),hl
	jp editvardraw


;------------------------------------------------
editvardown
	ld a,(row)
	cp 6
	jr z,editvarscrolldown
	ld b,a
	ld a,(rowmax)
	cp b
	jp z,editvarmovecol
	ld a,(row)
	inc a
	ld (row),a
	ld hl,(mr)
	ld de,5
	or a
	add hl,de
	ld (mr),hl
	ld a,(row)
	ld b,a
	ld a,(rowmax)
	cp b
	jp z,editvarscrolldownend
	jr editvardraw
editvarscrolldownend
	ld a,(col)
	ld b,a
	ld a,(colmax)
	cp b
	jr c,editvarmovecol
	jr editvardraw
editvarmovecol
	ld a,(colmax)
	ld (col),a
	jr editvardraw
editvarscrolldown
	ld a,(noscroll)
	cp 1
	jp z,editvarmovecol
	ld a,1
	ld (row),a
	ld hl,(mr)
	ld de,20
	or a
	sbc hl,de
	ld (mr),hl
	call drawrows
	res 3,(iy+5)								;set text display to black on white
	ld a,6
	ld (row),a
	ld hl,(mr)
	ld de,5
	or a
	sbc hl,de
	ld (mr),hl
	ld a,(col)
	ld b,a
	ld a,(colmax)
	cp b
	jr c,editvarmovecol
	jr editvardraw


;------------------------------------------------
editvardraw
	ld a,(mscroll)
	cp 1
	ret z
	ld a,(nodata)
	cp 1
	jp z,editvarkeyloop
	ld a,(full)
	cp 1
	jp z,drawgraphicsstart
	ld a,(rlast)
	ld (_curRow),a
	ld a,(clast)
	add a,16
	ld (_curCol),a
	call findundercur
	call _putmap
	ld a,(clast)
	ld b,a
	add a,a
	add a,b
	ld (_curCol),a
	ld a,(rlast)
	ld (_curRow),a
	ld b,2
drawclrlcurleft
	push bc
	call findundercur
	call _putc
	pop bc
	djnz drawclrlcurleft
	set 3,(iy+5)								;set text display to white on black
	ld a,(row)
	ld (_curRow),a
	ld a,(col)
	add a,16
	ld (_curCol),a
	call findundercur
	call _putmap
	call displaynum
	ld a,(graphicson)
	cp 1
	jp z,drawgraphicsstart
	ld a,(col)
	ld b,a
	add a,a
	add a,b
	ld (_curCol),a
	ld a,(row)
	ld (_curRow),a
	ld b,2
drawcrcurleft
	push bc
	call findundercur
	call _putc
	pop bc
	djnz drawcrcurleft
drawgraphicsend
	set 3,(iy+5)								;set text display to white on black
	ld a,(full)
	cp 1
	jp z,editvarkeyloop
	ld a,7
	ld (_curRow),a
	dec a
	ld (_curCol),a
	ld hl,(mr)
	ld a,(col)
	ld e,a
	ld d,0
	or a
	add hl,de
	inc hl
	ld a,(addressshow)
	or a										;does cp 0
	jr nz,drawaddressnum
	xor a										;does ld a,0
	dec hl
	call $4a33
drawaddressnumend
	res 3,(iy+5)								;set text display to black on white
	ld a,(row)
	ld (rlast),a
	ld a,(col)
	ld (clast),a
	ld a,(keypressed)
	or a										;does cp 0
	jp z,editvarkeyloop
	xor a										;does ld a,0
	ld (keypressed),a
	ld a,(keynum)
	jp editvarkeyloop_keypressed


;------------------------------------------------
drawaddressnum
	ld a,6
	ld (_curCol),a
	dec hl
	ex de,hl
	ld hl,(Addressoffset)
	add hl,de
	push hl
	ld a,h
	call disp_atohex
	pop hl
	ld a,l
	call disp_atohex
	ld a,4
	call _putc
	jr drawaddressnumend


;------------------------------------------------
drawgraphicsstart								;draws a variable width and variable hight black and white or grayscale graphic on screen
	call findcursorbyte							;finds the address of the currently highlighted byte
	dec hl
	ex de,hl
	ld hl,$fc7f
	ld (drawscreenloc),hl
	ex de,hl
begindraw
	ld a,(full)
	or a										;does cp 0
	jr z,begindrawa
	push hl
	ld hl,(drawscreenloc)
	ld de,128
	sbc hl,de
	ld (drawscreenloc),hl
	pop hl
begindrawa
	ld a,(graphichight)
	ld b,a
	xor a										;does ld a,0
	ld (graphrow),a
	ex de,hl
	ld hl,(drawscreenloc)
	ex de,hl
graphicrow
	push bc
	ld a,(graphicwidth)
	ld b,a
graphiccol
	inc hl
	inc de
	ld a,(hl)
	ex de,hl
	ld (hl),a
	ex de,hl
	djnz graphiccol

	push hl
	ld a,(graphrow)
	inc a
	ld (graphrow),a
	ld e,a
	ld d,0
	ld hl,0
	ld b,16
graphicrowaddloop
	add hl,de
	djnz graphicrowaddloop
	ex de,hl
	ld hl,(drawscreenloc)
	add hl,de
	ex de,hl
	pop hl
	pop bc
	djnz graphicrow
	ld a,(graystat)
	or a										;does cp 0
	jp z,endgraydraw
	ld a,(drewgray)
	or a										;does cp 0
	jr nz,endgraydraw
	ex de,hl
	ld hl,secondscreen+$7f
	ld (drawscreenloc),hl
	ex de,hl
	ld a,1
	ld (drewgray),a
	jp begindraw
endgraydraw
	xor a										;does ld a,0
	ld (drewgray),a
	jp drawgraphicsend



;------------------------------------------------
;------------------------------------------------
findundercur
	ld a,(_curRow)
	ld b,a
	ld de,21
	ld hl,0
findunderloop
	add hl,de
	djnz findunderloop
	ld a,(_curCol)
	ld e,a
	ld d,0
	add hl,de
	ld de,$c0f9
	add hl,de
	ld a,(hl)
	cp $d6
	ret nz
	ld a,$3a
	ret



;------------------------------------------------
;------------------------------------------------
displaynum
	ld hl,$8002
	ex de,hl
	ld hl,(mr)
	or a
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ld a,(col)
	ld e,a
	ld d,0
	add hl,de
	ld a,(hl)	
	ld b,a
	ld a,7
	ld (_curRow),a
	ld a,(hexbindec)
	or a										;does cp 0
	jr z,displayhex
	cp 1
	jr z,displaybin
	jr displaydec


;------------------------------------------------
displaydec
	ld a,b	
	call atodec
	ld a,18
	ld (_curCol),a
	ld hl,hexchars
	call _puts
	ret


;------------------------------------------------
displayhex
	ld a,18
	ld (_curCol),a
	ld a,b
	call disp_atohex
	ld a,4
	call _putmap
	ret


;------------------------------------------------
displaybin
	ld a,b
	call atobin
	ld a,12
	ld (_curCol),a
	ld hl,hexchars
	call _puts
	ld a,1
	call _putmap
	ret



;------------------------------------------------
;------------------------------------------------
addressontoggle
	ld a,(addressshow)
	cp 1
	jr z,addresstoff
	ld a,1
	ld (addressshow),a
	jp redrawscreen


;------------------------------------------------
addresstoff
	xor a										;does ld a,0
	ld (addressshow),a
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
fullgraphcontrol
	ld a,(full)
	or a										;does cp 0
	jr z,fullon
	jr fulloff


;------------------------------------------------
fullon
	ld a,1
	ld (full),a
	ld a,(graphicwidth)
	ld (widthalt),a
	ld a,(graphichight)
	ld (hightalt),a
	ld a,16
	ld (graphicwidth),a
	ld a,64
	ld (graphichight),a
	jp redrawscreen


;------------------------------------------------
fulloff
	xor a										;does ld a,0
	ld (full),a
	ld a,(widthalt)
	ld (graphicwidth),a
	ld a,(hightalt)
	ld (graphichight),a
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
grayscalecontrol
	ld a,(graystat)
	or a										;does cp 0
	jr z,grayon
	jr grayoff


;------------------------------------------------
grayon
	ld a,1
	ld (graystat),a
	set 2,(iy+$23)
	jp redrawscreen


;------------------------------------------------
grayoff
	xor a										;does ld a,0
	ld (graystat),a
	res 2,(iy+$23)
	ld a,$3c									;sets the current display plane to the default plane at $FC00
	out (0),a									;
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
graphicstoggle
	ld a,(graphicson)
	cp 1
	jr z,graphicsturnoff
	jr graphicsturnon



;------------------------------------------------
graphicsturnoff
	xor a										;does ld a,0	
	ld (graphicson),a
	jp redrawscreen


;------------------------------------------------
graphicsturnon
	inc a
	ld (graphicson),a
	jp redrawscreen





;------------------------------------------------
;------------------------------------------------
graphwidthup
	ld a,(graphicwidth)
	cp 16
	jp z,redrawscreen
	inc a
	ld (graphicwidth),a
	jp redrawscreen


;------------------------------------------------
graphwidthdown
	ld a,(graphicwidth)
	cp 1
	jp z,redrawscreen
	dec a
	ld (graphicwidth),a
	jp redrawscreen


;------------------------------------------------
graphhightup
	ld a,(inchightnum)
	ld b,a
graphhightupa
	ld a,(graphichight)
	cp 48
	jp z,redrawscreen
	inc a
	ld (graphichight),a
	djnz graphhightupa
	jp redrawscreen


;------------------------------------------------
graphhightdown
	ld a,(inchightnum)
	ld b,a
graphhightdowna
	ld a,(graphichight)
	cp 8
	jp z,redrawscreen
	dec a
	ld (graphichight),a
	djnz graphhightdowna
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
graphicinccontrol
	ld a,(inchightnum)
	cp 1
	jr z,graphincby8
	jr graphincby1


;------------------------------------------------
graphincby1
	ld a,1
	ld (inchightnum),a
	jr redrawscreen


;------------------------------------------------
graphincby8
	ld a,8
	ld (inchightnum),a
	jr redrawscreen




;------------------------------------------------
;------------------------------------------------
hexbindecdecide
	call drawsecscreen							;clear the alternate display plane
	call Bydraw
	ld a,1
	ld b,2
	ld hl,displaydecidetable
	call putflines
	call clear_key_flags_getkey
	cp k1
	jr z,hexdecide
	cp k2
	jr z,bindecide
	cp k3
	jr z,decdecide
	cp kF2
	jr z,redrawscreen
	jr hexbindecdecide


;------------------------------------------------
hexdecide
	xor a										;does ld a,0
	ld (hexbindec),a
	jr redrawscreen


;------------------------------------------------
bindecide
	ld a,1
	ld (hexbindec),a
	jr redrawscreen


;------------------------------------------------
decdecide
	ld a,2
	ld (hexbindec),a
	jr redrawscreen




;------------------------------------------------
;------------------------------------------------
redrawscreen
	call drawsecscreen							;clear the alternate display plane
	call editvardrawscreen
	res 3,(iy+5)								;set text display to black on white
	ld a,(row)
	ld (rsave),a
	ld a,(col)
	ld (csave),a
	ld a,(rlast)
	ld (rlastsave),a
	ld a,(clast)
	ld (clastsave),a
	ld hl,(mr)
	ld (mrsave),hl
	ld a,(row)
	dec a
	ld b,a
	add a,a
	add a,a
	add a,b
	ld e,a
	ld d,0
	sbc hl,de
	ld (mr),hl
	ld a,1
	ld (row),a
	xor a										;does ld a,0
	ld (col),a
	call drawrows
	ld hl,(mrsave)
	ld (mr),hl
	ld a,(rsave)
	ld (row),a
	ld a,(csave)
	ld (col),a
	ld a,(rlastsave)
	ld (rlast),a
	ld a,(clastsave)
	ld (clast),a
	jp editvardraw


;------------------------------------------------
redrawscreena
	pop hl
	jp redrawscreen




;------------------------------------------------
;------------------------------------------------
cphlsize
	push hl
	ld de,$8000
	or a
	sbc hl,de
	inc hl
	inc hl
	ex de,hl
	ld hl,(tsize)
	inc hl
	call $403c					;compares hl,de; works like compare a,b
	jr c,cphlnoscroll
	xor a										;does ld a,0
	ld (noscroll),a
	pop hl
	ret
cphlnoscroll
	pop hl
	ld a,1
	ld (noscroll),a
	ret



;------------------------------------------------
;------------------------------------------------
draweditscreen
	xor a										;does ld a,0
	ld (noscroll),a
	ld (nodata),a
	ld (col),a
	ld (clast),a
	ld a,1
	ld (rlast),a
	ld (row),a
	ld hl,0
	ld (mr),hl	
drawrows
	ld b,6
drawrowsloop
	push bc
	call draweditrow
	pop bc
	ld de,5
	ld hl,(mr)
	or a
	add hl,de
	ld (mr),hl
	ld a,(row)
	inc a
	ld (row),a
	ld a,(nodata)
	cp 1
	ret z
	ld a,(noscroll)
	cp 1
	ret z
	djnz drawrowsloop
	ret


;------------------------------------------------
draweditrow
	ld hl,$8002
	ex de,hl
	ld hl,(mr)
	or a
	add hl,de
	ld a,(sizeoff)
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ld a,1
	cp b
	call firsttimethrough
	ld a,16
	ld (_curCol),a
	ld a,(row)
	ld (_curRow),a
	ld b,5
drawcolloop
	ld a,(full)
	cp 1
	jp z,drawnorighttext
	ld a,(mscroll)
	cp 1
	jr z,drawnorighttexta
	ld a,(hl)
	call atohex
	cp $d6
	jr nz,drawcolloopnenter
	ld a,$3a
drawcolloopnenter
	call _putc
drawnorighttext
	inc hl
	call cphlsize
	ld a,(mscroll)
	cp 1
	jr z,endskipredraw
	ld a,(_curCol)
	ld c,a
	ld a,(_curRow)
	push af
	push bc
	push hl
	ld a,(graphicson)
	or a										;does cp 0
	jr nz,drawcolloopnotext
	ld a,(_curCol)
	or a										;does cp 0
	call z,enddrawcolloop4a
	sub 17
	ld b,a
	add a,a
	add a,b
	ld (_curCol),a
	ld hl,hexchars
	call _puts
drawcolloopnotext
	pop hl
	pop bc
	pop af
	ld (_curRow),a
	ld a,c
	ld (_curCol),a
endskipredraw
	ld a,(noscroll)
	cp 1
	jr z,enddrawcolloop
	djnz drawcolloop
	ret


;------------------------------------------------
drawnorighttexta
	ld a,(_curCol)
	inc a
	cp 22
	jr nz,drawnorighttextab
	ld a,(_curRow)
	inc a
	ld (_curRow),a
	xor a										;does ld a,0
drawnorighttextab
	ld (_curCol),a
	jp drawnorighttext


;------------------------------------------------
enddrawcolloop
	ld a,(_curCol)
	or a										;does cp 0
	call z,enddrawcolloop4a
	sub 17
	ld (colmax),a
	ld a,(_curRow)
	ld (rowmax),a
enddrawcolloop2
	ld a,(_curCol)
	or a										;does cp 0
	ret z
	ld a,$20
	call _putc
	ld a,6
	ld (_curRow),a
	ld a,(_curCol)
	ld c,a
	push bc
	or a										;does cp 0
	call z,enddrawcolloop4
	sub 17
	ld b,a
	add a,a
	add a,b
	ld (_curCol),a
	ld a,$20
	call _putc
	ld a,$20
	call _putc
	pop bc
	ld a,c
	ld (_curCol),a
	jr enddrawcolloop2


;------------------------------------------------
enddrawcolloop4a
	ld a,(_curRow)
	dec a
	ld (_curRow),a
	ld a,21
	ret


;------------------------------------------------
enddrawcolloop4
	ld a,21
	ret


;------------------------------------------------
nodatainvar
	pop hl
	ld a,1
	ld (nodata),a
	ret


;------------------------------------------------
firsttimethrough
	ld a,(row)
	cp 1
	ret nz
	call cphlsize
	ld a,(noscroll)
	cp 1
	jp z,nodatainvar
	ret



;------------------------------------------------
;------------------------------------------------
findcursorbyte									;finds the address of the currently highlighted byte
	ld de,$8002									;address of the start of the current page+2
	ld hl,(mr)									;bytes to add for currently selected row
	or a										;clear carry flag
	add hl,de									;add the numbers
	ld a,(sizeoff)								;number of bytes to subtract from the start address
	ld e,a										;move to least significant byte
	ld d,0										;clear most significant byte
	or a										;clear carry flag
	sbc hl,de									;subtract the numbers
	ld a,(col)									;currently selected colomn
	ld e,a										;move to least significant byte
	ld d,0										;clear most significant byte
	add hl,de									;add addresses
	ret											;return





;------------------------------------------------
;------------------------------------------------
find_var_bottom
	call search_draw_scrolling					;inverts bottom row, draws "Scrolling..." text inverted
	ld a,1
	ld (mscroll),a
find_var_bottomloop
	ld a,(noscroll)
	cp 1
	jp z,find_var_bottomend
	call editvardown
	jr find_var_bottomloop


;------------------------------------------------
find_var_bottomend
	call editvardown
	xor a										;does ld a,0
	ld (mscroll),a
	jp redrawscreen





;------------------------------------------------
;------------------------------------------------
putflines										; originally from Putz!
	ld (_curCol),a
	ld (pcol),a
	ld a,b
	ld (_curRow),a
	ld (prow),a
putflinesloop
	call _puts
	ld a,(pcol)
	ld b,a
	ld a,(_curCol)
	cp b
	ret z
	ld a,(prow)
	inc a
	ld (prow),a
	ld (_curRow),a
	ld a,(pcol)
	ld (_curCol),a
	jr putflinesloop






;------------------------------------------------
;------------------------------------------------
drawsecscreen
	ld hl,secondscreen
	ld de,secondscreen+1
	ld (hl),$ff
	ld bc,127
	ldir
	ld hl,secondscreen+$80
	ld de,secondscreen+$81
	ld bc,770
	ld (hl),0
	ldir
	ld hl,secondscreen+$380
	ld de,secondscreen+$381
	ld bc,127
	ld (hl),$ff
	ldir
	ret




;------------------------------------------------
;------------------------------------------------
Levelchange
	ld a,(lev)
	ld (pr),a
	jr Levelnumdraw


;------------------------------------------------
Levelchangeloop
	call clear_key_flags_getkey
	cp kF2
	jp z,Selectwhat2load2
	cp kExit
	jp z,mEnd
	cp kEnter
	jr z,Levelchangeend
	cp kUp
	jr z,Levelgoesup
	cp kDown
	jr z,Levelgoesdown
	jr Levelchangeloop


;------------------------------------------------	
Levelgoesup
	ld a,(pr)
	or a										;does cp 0
	jr z,Levelloopup
	ld a,(pr)
	dec a
	ld (pr),a
	jr Levelnumdraw


;------------------------------------------------
Levelgoesdown
	ld a,(pr)
	ld b,a
	ld a,(maxlevs)
	cp b
	jr z,Levelloopdown
	ld a,(pr)
	inc a
	ld (pr),a
	jr Levelnumdraw


;------------------------------------------------
Levelloopup
	ld a,(maxlevs)
	ld (pr),a
	jr Levelnumdraw


;------------------------------------------------
Levelloopdown
	xor a										;does ld a,0
	ld (pr),a
	jr Levelnumdraw


;------------------------------------------------
Levelnumdraw
	ld hl,0
	ld a,(pr)
	call atohex
	ld hl,hexchars+1
	call _puts
	ld a,(_curCol)
	sub 1
	ld (_curCol),a
	jr Levelchangeloop


;------------------------------------------------
Levelchangeend
	ld a,(pr)
	ld (lev),a
	ret



;------------------------------------------------
;------------------------------------------------
editcheckifasm
	ld hl,File_name-1
	rst 20h
	rst 10h
	ex de,hl
	inc hl
	inc hl
	ld a,b
	call $521d
	ld hl,$288e
	call $403c
	ret nz
	ld hl,$d746
	ld (Addressoffset),hl
	ld a,1
	ld (search_addr_available),a
	ret


;------------------------------------------------
drawgraphicsenda
	pop hl
	jp drawgraphicsend



;------------------------------------------------
;------------------------------------------------
SortVAT
	ld a,(vatsorted)
	cp 1
	ret z
	ld a,1
	ld (vatsorted),a
	call $47f3									;load RAM page 7
	ld hl,vat_bottom+1
	ld (vat_sorted_top),hl
main_loop
	ld hl,(vat_top)
	ex de,hl
	ld hl,(vat_sorted_top)
	dec hl
	or a
	sbc hl,de
	jr z,end
	ld hl,(vat_sorted_top)
	dec hl
	ld (cur_bottom),hl
	call get_cur_info
	ld hl,(cur_top)
	dec hl
	ld (check_bottom),hl
	call check_it
	call vat_rewrite
	jr main_loop


;------------------------------------------------
end
	call $47e3
	ret


;------------------------------------------------
check_it
check_loop
	call get_check_info
	call rank_check
	or a										;does cp 0
	jr z,check_not_smaller
	ld hl,(check_bottom)
	ld (cur_bottom),hl
	call get_cur_info


;------------------------------------------------
check_not_smaller
	ld hl,(check_top)
	dec hl
	ld (check_bottom),hl
	ex de,hl
	ld hl,(vat_top)
	or a
	sbc hl,de
	ret z
	jr check_loop


;------------------------------------------------
vat_rewrite
	ld hl,(cur_bottom)
	inc hl
	ex de,hl
	ld hl,(vat_sorted_top)
	or a
	sbc hl,de
	jr z,no_vat_rewrite
	ld hl,(cur_bottom)
	ex de,hl
	ld hl,(vat_sorted_top)
	dec hl
	or a
	sbc hl,de
	ld c,l
	ld b,h
	ld hl,(cur_top)
	ex de,hl
	ld hl,(cur_bottom)
	inc hl
	ldir
	push de
	push de
	ld hl,(entry_size)
	ld c,l
	ld b,h
	ld hl,entry
	pop de
	ldir
	pop hl
end_vat_rewrite
	ld (vat_sorted_top),hl
	ret


;------------------------------------------------
no_vat_rewrite
	ld hl,(cur_top)
	jr end_vat_rewrite


;------------------------------------------------
get_check_info_error
	pop hl
	pop hl
	pop hl
	ret


;------------------------------------------------
get_check_info									;only requires check_bottom
	ld hl,(check_bottom)
	push hl
	ex de,hl
	ld hl,(vat_top)
	or a
	sbc hl,de
	jr z,get_check_info_error
	pop hl
	ld de,5
	or a
	sbc hl,de
	push hl
	ld a,(hl)
	ld e,a
	ld d,0
	sbc hl,de
	ld (check_top),hl
	ld hl,var_name2
	ld de,var_name2+1
	ld bc,7
	push af
	xor a										;does ld a,0
	ld (hl),a
	pop af
	ldir
	ld c,a
	ld b,0
	ld de,var_name2_end
	pop hl
	dec hl
	lddr
	ret


;------------------------------------------------
get_cur_info									;only requires cur_bottom
	ld hl,(cur_bottom)
	ld de,5
	or a
	sbc hl,de
	push hl
	ld a,(hl)
	ld e,a
	ld d,0
	sbc hl,de
	ld de,entry
	add a,6
	ld c,a
	ld b,0
	push bc
	ld (cur_top),hl
	ldir
	pop hl
	ld (entry_size),hl
	ld hl,var_name1
	ld de,var_name1+1
	ld bc,8
	push af
	xor a										;does ld a,0
	ld (hl),a
	pop af
	ldir
	sub 6
	ld c,a
	ld b,0
	ld de,var_name1_end
	pop hl
	dec hl
	lddr
	ret


;------------------------------------------------
rank_check										;a=1 if smaller varname2 smaller than varname1, a=0 else
	ld hl,var_name1_end
	ld de,var_name2_end
	ld c,0
rank_check_loop
	inc c
	ld a,c
	cp 9
	jr z,rank_check_bigger
	ld a,(hl)
	ld b,a
	ex de,hl
	ld a,(hl)
	ex de,hl
	dec hl
	dec de
	cp b
	jr z,rank_check_loop
	cp b
	jr c,rank_check_smaller
	jr rank_check_bigger


;------------------------------------------------
rank_check_bigger
	xor a										;does ld a,0
	ret


;------------------------------------------------
rank_check_smaller
	ld a,1
	ret



;------------------------------------------------
;------------------------------------------------
clear_key_flags_getkey
	res 3,(iy+18)
	res 4,(iy+18)
	res 5,(iy+18)
	res 6,(iy+18)
	res 7,(iy+18)
	call _getkey
	ret



;------------------------------------------------
;------------------------------------------------
addr_input
	res 2,(iy+$1e)								;turn off 2nd and alpha display in upper right hand corner of the screen
	ld a,7
	call Invbar
	xor a										;does ld a,0
	ld (cur_char),a
	ld hl,input_chars
	ld a,$30
	ld (hl),a
	ld a,(hexbindec)
	or a										;does cp 0
	jp z,addr_hex_setup
	cp 1
	jp z,addr_bin_setup
	jp addr_dec_setup


;------------------------------------------------
addr_input_setup_finish
	ld de,input_chars+1
	ldir
	ex de,hl
	ld (hl),a
	inc hl
	xor a										;does ld a,0
	ld (hl),a
	jp addr_input_draw


;------------------------------------------------
addr_input_key_loop
	call _getkey
	cp kF2
	jp z,finish_save_addr
	cp kEnter
	jp z,finish_save_addr
	cp kExit
	jp z,finish_addr
	cp kLeft
	jp z,addr_input_left
	cp kRight
	jr z,addr_input_right
	cp kDel
	jr z,addr_input_del
	sub $1c
	cp 1
	jr z,addr_enter_char
	jr c,addr_enter_char
	push af
	ld a,(hexbindec)
	cp 1
	jr z,addr_input_key_loop_pop
	pop af
	cp 9
	jr z,addr_enter_char
	jr c,addr_enter_char
	push af
	ld a,(hexbindec)
	cp 2
	jr z,addr_input_key_loop_pop
	pop af
	sub $2
	cp $10
	jr nc,addr_input_key_loop
	jr addr_enter_char


;------------------------------------------------
addr_input_key_loop_pop
	pop af
	jr addr_input_key_loop


;------------------------------------------------
addr_input_del
	ld a,(cur_char)
	or a										;does cp 0
	jr z,addr_input_draw
	dec a
	ld (cur_char),a
	ld hl,input_chars
	ld a,(cur_char)
	ld e,a
	ld d,0
	or a
	add hl,de
	ld a,$30
	ld (hl),a
	jr addr_input_draw


;------------------------------------------------
addr_input_right
	ld a,(max_inputchars)
	ld b,a
	ld a,(cur_char)
	cp b
	jr z,addr_input_draw
	inc a
	ld (cur_char),a
	jr addr_input_draw


;------------------------------------------------
addr_input_left
	ld a,(cur_char)
	or a										;does cp 0
	jr z,addr_input_draw
	dec a
	ld (cur_char),a
	jr addr_input_draw


;------------------------------------------------
addr_enter_char
	cp $a
	jr nc,addr_enter_no_add
	add a,$30
addr_enter_no_add
	ld hl,input_chars
	push af
	ld a,(max_inputchars)
	ld b,a
	ld a,(cur_char)
	ld e,a
	cp b
	jr z,addr_input_draw_pop
	inc a
	ld (cur_char),a
	ld d,0
	or a
	add hl,de
	pop af
	ld (hl),a
	jr addr_input_draw


;------------------------------------------------
addr_input_draw_pop
	pop af
addr_input_draw
	res 2,(iy+12)
	ld a,7
	ld (_curRow),a
	set 3,(iy+5)								;set text display to white on black
	ld a,(start_col)
	ld (_curCol),a
	ld hl,input_chars
	call _puts
	ld a,(start_col)
	ld b,a
	ld a,(cur_char)
	ld e,a
	add a,b
	ld (_curCol),a
	ld a,7
	ld (_curRow),a
	ld d,0
	ld hl,input_chars
	or a
	add hl,de
	ld a,(hl)
	ld (_curUnder),a
	set 2,(iy+12)
	jp addr_input_key_loop


;------------------------------------------------
finish_save_addr
	call addr_input_convert_and_end
	ld (search_addr),hl
finish_addr
	set 2,(iy+$1e)
	res 2,(iy+12)
	res 3,(iy+5)								;set text display to black on white
	jp redrawscreen



;------------------------------------------------
;------------------------------------------------
addr_input_convert_and_end
	ld hl,input_chars
	ld a,(hexbindec)
	or a										;does cp 0
	jr z,hex_strng_to_hl
	cp 1
	jr z,bin_strng_to_hl
	jr dec_strng_to_hl


;------------------------------------------------
bin_strng_to_hl
	ld de,0
	ld b,16
	or a
bin_strng_hl_loop
	rl e
	rl d
	ld a,(hl)
	sub $30
	add a,e
	ld e,a
	inc hl
	djnz bin_strng_hl_loop
	ex de,hl
	ret


;------------------------------------------------
dec_strng_to_hl
	ld a,(hl)
	inc hl
	push hl
	and $0f
	inc a
	ld de,$2710
	ld hl,-$2710
	ld b,a
	or a
tenk_loop
	add hl,de
	djnz tenk_loop
	ex de,hl
	pop hl
	ld a,(hl)
	inc hl
	push hl
	ld hl,-$3e8
	add hl,de
	ld de,$3e8
	and $0f
	inc a
	ld b,a
	or a
onek_loop
	add hl,de
	djnz onek_loop
	ex de,hl
	pop hl
	ld a,(hl)
	inc hl
	push hl
	ld hl,-$64
	add hl,de
	ld de,$64
	and $0f
	inc a
	ld b,a
	or a
oneh_loop
	add hl,de
	djnz oneh_loop
	ex de,hl
	pop hl
	ld a,(hl)
	inc hl
	push hl
	ld hl,-$a
	add hl,de
	ld de,$a
	and $0f
	inc a
	ld b,a
	or a
onet_loop
	add hl,de
	djnz onet_loop
	ex de,hl
	pop hl
	ld a,(hl)
	and $0f
	ld l,a
	ld h,0
	add hl,de
	ret


;------------------------------------------------
hex_strng_to_hl			;address of string in hl
	ld de,string_copy
	ld bc,4
	ldir
	ld hl,string_copy
	xor a										;does ld a,0
	rrd
	rrca
	rrca
	rrca
	rrca	
	inc hl
	rrd
	ld d,a
	inc hl
	rrd
	rrca
	rrca
	rrca
	rrca	
	inc hl
	rrd
	ld e,a
	ex de,hl
	ret


;------------------------------------------------
addr_hex_setup
	ld a,16
	ld (start_col),a
	ld a,4
	ld (max_inputchars),a
	ld bc,3
	ld a,4
	jp addr_input_setup_finish


;------------------------------------------------
addr_bin_setup
	xor a										;does ld a,0
	ld a,4
	ld (start_col),a
	ld a,16
	ld (max_inputchars),a
	ld bc,15
	ld a,1
	jp addr_input_setup_finish


;------------------------------------------------
addr_dec_setup
	xor a										;does ld a,0
	ld a,15
	ld (start_col),a
	ld a,5
	ld (max_inputchars),a
	ld bc,4
	ld a,3
	jp addr_input_setup_finish



;------------------------------------------------
;------------------------------------------------
installint
;thanks to Matt Johnson for this bit of code
_user_int_ram EQU $d2fd                      ;Area where interrupt handler goes
;====================================================================================================
; Install IM 1 Interrupt Handler
;====================================================================================================
 res 2,(iy+$23)                       ;turn user int off so it won't get called by
                                      ;accident before we're ready   
 ld hl,int_copy                       ;copy prog to user int buffer
 ld de,_user_int_ram+1                ;1 byte ahead of checksum
 ld bc,int_end-int_start              ;length of interrupt handler
 ldir                                 ;hl is the source, de is the destination,
                                      ;and bc is the length   
 ld a,(_user_int_ram+1)               ;set up checksum byte
 ld hl,_user_int_ram+($28*1)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*2)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*3)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*4)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*5)          ;load byte
 add a,(hl)                           ;add to total
 ld (_user_int_ram),a                 ;load checksum in its location
 ret                                  ;Return to shell or TI-OS




;------------------------------------------------
;------------------------------------------------
inchightnum
.db 8
graphicwidth
.db 1
graphichight
.db 16

;------------------------------------------------
Abouttxt
.db "Hex Viewer",0
.db "version "
versionnum
.db ".96",0
spaces
.db "         ",0
.db "Report bugs to:",0
.db "saywhat97@hotmail.com",0,0
name
.db "Hex Viewer .96 by John Kempen",0
charselecttxt
.db "Character",6,"/",7,":",0
previous
.db "Previous:",0
current
.db "Current:",0
displaydecidetable
.db "1 Hexadecimal",0
.db "2 Binary",0
.db "3 Decimal",0,0
hexcharstable
.db "0123456789",$0a,$0b,$0c,$0d,$0e,$0f
bytext
.db "By John Kempen",0
nametext
.db "Hex Viewer",0
Selectwhattxt
.db "1 Load Variable",0
.db "2 "
lrampage
.db "Load Ram "
pagetxt
.db "Page",0
.db "3 "
lrompage
.db "Load Rom Page",0
.db "4 About",0
.db "5 Help",0
.db "6 Exit",0,0
Page
.db "Load page ",0
nostring
.db "No search string!",0
stringnotfound
.db "String not found",0
sorting
.db "Sorting...",0
searching
.db "Searching...",0
scrollingtxt
.db "Scrolling...",0
search_address_outofrange_txt
.db "Out of range",0
nohelpviewer
.db "Need file: HelpView",0
HelpView
.db 8,"HelpView"


;------------------------------------------------
textfiledata
maxrow
.db 7
minrow
.db 1
maxcol
.db 20
mincol
.db 0
textvariable
.db 7,"HexHelp"


;------------------------------------------------
varreal
.db 2
textreal
.db "Real ",0
varcplx
.db 2
textcplx
.db "Cplx ",0
varvectr
.db 0,"Vectr",0
varlist
.db 0,"List ",0
varmatrx
.db 0,"Matrx",0
varcons
.db 2,"Cons ",0
varequ
.db 0,"Equ  ",0
varstrng
.db 0,"Strng",0
vargdb
.db 0,"Gdb  ",0
varpic
.db 0,"Pic  ",0
varprgm
.db 0,"Prgm ",0
varunknown
.db 2
textno
.db "     ",0
textfunc
.db "Func ",0
textpol
.db "Pol  ",0
textparam
.db "Param",0
textdifeq
.db "DifEq",0
textos
.db "Os?  ",0
varram
.db 2,"Ram  ",0
varrom
.db 2,"Rom  ",0


;------------------------------------------------
typetxttable
;0
.dw textno
.dw varreal
;1
.dw textno
.dw varcplx
;2
.dw textreal
.dw varvectr
;3
.dw textcplx
.dw varvectr
;4
.dw textreal
.dw varlist
;5
.dw textcplx
.dw varlist
;6
.dw textreal
.dw varmatrx
;7
.dw textcplx
.dw varmatrx
;8
.dw textreal
.dw varcons
;9
.dw textcplx
.dw varcons
;a
.dw textno
.dw varequ
;b
.dw textos
.dw varunknown
;c
.dw textno
.dw varstrng
;d
.dw textfunc
.dw vargdb
;e
.dw textpol
.dw vargdb
;f
.dw textparam
.dw vargdb
;10
.dw textdifeq
.dw vargdb
;11
.dw textno
.dw varpic
;12
.dw textno
.dw varprgm
;13
.dw textos
.dw varunknown
;14
.dw textos
.dw varunknown
;15
.dw textos
.dw varunknown
;16
.dw textos
.dw varunknown
;17
.dw textos
.dw varunknown
;18
.dw textos
.dw varunknown
;19
.dw textos
.dw varunknown
;1a
.dw textos
.dw varunknown
;1b
.dw textos
.dw varunknown
;1c
.dw textos
.dw varunknown
;1d
.dw textos
.dw varunknown
;1e
.dw textos
.dw varunknown
;1f
.dw textos
.dw varunknown
;20
.dw textno
.dw varram
;21
.dw textno
.dw varrom



;------------------------------------------------
keytable
.db $3a		;$05
.db 0		;$06
.db 0		;$07
.db 0		;$08
.db 0		;$09
.db 0		;$0a
.db 0		;$0b
.db $2b		;$0c
.db $2d		;$0d
.db $2a		;$0e
.db $2f		;$0f
.db $5e		;$10
.db $28		;$11
.db $29		;$12
.db $5b		;$13
.db $5d		;$14
.db $3d		;$15
.db $1c		;$16
.db 0		;$17
.db $2c		;$18
.db $13		;$19
.db $1a		;$1a
.db $2e		;$1b
.db $30		;$1c
.db $31		;$1d
.db $32		;$1e
.db $33		;$1f
.db $34		;$20
.db $35		;$21
.db $36		;$22
.db $37		;$23
.db $38		;$24
.db $39		;$25
.db $1b		;$26
.db $20		;$27
.db $41		;$28
.db $42		;$29
.db $43		;$2a
.db $44		;$2b
.db $45		;$2c
.db $46		;$2d
.db $47		;$2e
.db $48		;$2f
.db $49		;$30
.db $4a		;$31
.db $4b		;$32
.db $4c		;$33
.db $4d		;$34
.db $4e		;$35
.db $4f		;$36
.db $50		;$37
.db $51		;$38
.db $52		;$39
.db $53		;$3a
.db $54		;$3b
.db $55		;$3c
.db $56		;$3d
.db $57		;$3e
.db $58		;$3f
.db $59		;$40
.db $5a		;$41
.db $61		;$42
.db $62		;$43
.db $63		;$44
.db $64		;$45
.db $65		;$46
.db $66		;$47
.db $67		;$48
.db $68		;$49
.db $69		;$4a
.db $6a		;$4b
.db $6b		;$4c
.db $6c		;$4d
.db $6d		;$4e
.db $6e		;$4f
.db $6f		;$50
.db $70		;$51
.db $71		;$52
.db $72		;$53
.db $73		;$54
.db $74		;$55
.db $75		;$56
.db $76		;$57
.db $77		;$58
.db $78		;$59
.db $79		;$5a
.db $7a		;$5b
.db $09		;$5c
.db 0		;$5d
.db $c4		;$5e
.db $11		;$5f
.db 0		;$60
.db 0		;$61
.db 0		;$62
.db 0		;$63
.db 0		;$64
.db 0		;$65
.db $12		;$66
.db $10		;$67
.db 0		;$68
.db $65		;$69
.db 0		;$6a
.db $1d		;$6b




;------------------------------------------------
;------------------------------------------------
;thanks to Matt Johnson for this bit of code
;====================================================================================================
; IM 1 Interrupt Handler code
;====================================================================================================
int_copy:
	.org $D2FE									; Intruction Counter starts at $D2FE
int_start:										;start of interrupt code
	in a,(3)									; Is the LCD in the middle of refreshing?
	bit 1,a										;
	ret z										; If so, immediately exit interrupt routine

	ld a,(time)
	inc a										;increment timer
	ld (time),a									;
	cp 3
	jr z,lower									;loads second display plane
	cp 1
	jr z,upper									;loads first display plane
	ret											;return to TI-OS interrupt routine

upper
	ld a,$3c									;sets the current display plane to the default plane at $FC00
	out (0),a									;
	ret											;return to TI-OS interrupt routine
lower
	xor a										;does ld a,0
	ld (time),a									;reset counter
	ld a,secondscreen_port						;sets the current display plane to the second plane
	out (0),a									;
	ret											;return to TI-OS interrupt routine
int_end


.db "2/13/1999-"
.db "1/23/2000"

.end








